var express = require('express'),
    app = express(),
    server = require('http').createServer(app),
    io = require('socket.io').listen(server);
var flash = require('connect-flash');
var Flukso = require("./flukso");
var IpPoll = require("./ip-poll");
var routes = require("./routes");
var path = require('path');
var mqttClient = require('mqtt');
var process = require('process')
// +49 231 8 404 777
var spaceanswer = {
    api: "0.13",
    ext_ccc: "erfa",
    space: "Chaostreff Dortmund",
    logo: "https://www.chaostreff-dortmund.de/presse/logo/logo_ctdo.png",
    icon: {
        open: "https://status.ctdo.de/img/green.png",
        closed: "https://status.ctdo.de/img/red.png"
    },
    url: "https://www.chaostreff-dortmund.de/",
    location: {
        address: "Braunschweiger Str 22, 44145 Dortmund, Germany",
        lon: 7.4649449,
        lat: 51.527611
    },
    contact: {
        phone: "",
        irc: "irc://irc.hackint.eu/#ccc.do",
        ml: "discuss@lists.chaostreff-dortmund.de",
        twitter: "@ctdo",
        issue_mail: "hostmaster@chaostreff-dortmund.de"
    },
    issue_report_channels: ["issue_mail"],
    state: {
        open: null,
        lastchange: 0,
        icon: {
            open: "https://status.ctdo.de/img/green.png",
            closed: "https://status.ctdo.de/img/red.png"
        }
    },
    feeds: {
        blog: {
            type: "application/rss+xml",
            url: "https://www.chaostreff-dortmund.de/feed/"
        },
        calendar: {
            type: "ical",
            url: "https://www.chaostreff-dortmund.de/events.ics"
        }
    },
    sensors: {
        power_consumption: [{
            unit: "W",
            name: "mains power",
            description: "overall power consumption from our space",
            location: "basement",
            value: 0
        }]
    }
};
var simpleanswer = {state: "unknown", lastchange: 0, power: 0};


var ippoll = new IpPoll(process.env.STATUS_POLL_HOST || "snapserv.raum.ctdo.de");
var flukso = new Flukso(process.env.FLUKSO_HOST || "flukso.raum.ctdo.de",
    process.env.FLUKSO_URL || "/sensor/cf00e0b22230f4a8870af58f2b8719dd");
var mqtt = mqttClient.connect(process.env.MQTT_SERVER || 'mqtt://mqtt.ctdo.de');
var connected = false;

//express js settings
var port = process.env.HTTP_PORT || '9911';
var address = '0.0.0.0';

process.on('SIGINT', () => {
    console.info("Interrupted")
    process.exit(0)
})

ippoll.on('doneState', function (state) {
    spaceanswer.state.open = state;
    spaceanswer.state.lastchange = Math.floor(new Date().getTime() / 1000);
    simpleanswer.state = state;
    simpleanswer.lastchange = spaceanswer.state.lastchange;
    simpleanswer.lastchange = new Date().getTime();
    io.sockets.emit('sdata', {data: simpleanswer});
    console.log("room state changed: " + JSON.stringify(simpleanswer))
});

flukso.on('done', function (num) {
    simpleanswer.power = num;
    spaceanswer.sensors.power_consumption[0].value = num;
    io.sockets.emit('sdata', {data: simpleanswer});
});

flukso.on('failed', function (error) {
    console.log("Flukso: " + error);
});

mqtt.on('connect', function () {
    console.log("connected to mqtt");
    mqtt.subscribe('raumstatus/simple');
});

mqtt.on('message', function (topic, message) {
    if (topic === 'raumstatus/simple') {
        connected = (message.toString() === 'true');
    }
});

function sendSimple() {
    mqtt.publish('raumstatus/simple', JSON.stringify(simpleanswer));
}

function work() {
    ippoll.pollState();
    sendSimple();
}

setInterval(work, process.env.PING_INTERVAL_MS || 60000);
work();

setInterval(flukso.pollPower, 5000);
flukso.pollPower();

app.use(express.static('public'));
app.use(flash());

app.set('/views');
app.set('view engine', 'jade');
app.disable('x-powered-by');
app.enable('trust proxy');

app.get('/api/spaceapi/v13', function (req, res) {
    res.setHeader("Access-Control-Allow-Origin", "*");
    res.setHeader("Cache-Control", "no-cache");
    res.send(spaceanswer);
});

app.get('/api/simple/v2', function (req, res) {
    res.setHeader("Access-Control-Allow-Origin", "*");
    res.setHeader("Cache-Control", "no-cache");
    res.send(simpleanswer);
});


function getstatusImage(req, res) {
    if (spaceanswer.state.open === true) {
        res.sendFile(path.resolve(__dirname, 'public/img/green.png'));
    } else if (spaceanswer.state.open === false) {
        res.sendFile(path.resolve(__dirname, 'public/img/red.png'));
    } else {
        res.sendFile(path.resolve(__dirname, 'public/img/yellow.png'));
    }
}

app.get('/api/simple/image', function (req, res) {
    getstatusImage(req, res);
});

app.get('/api/simple/image.png', function (req, res) {
    getstatusImage(req, res);
});


app.get('/', routes.index);

var server = server.listen(port, address, function (err) {
    if (err) {
        console.log(err);
    }

    var message = 'Server is running @ http://' + address + ':' + port;
    console.log(message);
});
